/*
 * @Overview 부서 등록
 */

class Tb_dept_class {
  constructor(container) {
    this.ajaxUrl = "./dept.ajax.php";
    this.isEdited = false;

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table#dept_table");
    this.widthBtn =  this.container.querySelector(".width-btn");
    this.addBtn = this.container.querySelector(".add-btn");
    this.removeBtn = this.container.querySelector(".remove-btn");
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList() {
    let talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);
    
    const bizNmInput = document.querySelector("#BIZ_AREA_NM").value;
    const deptNmInput = document.querySelector("#DEPT_NM").value;
    const useFlgCheckbox = document.querySelector("#use_flag").value;

    ajax_json({
      url: this.ajaxUrl,
      data: {
        mode: "getDeptList",
        BIZ_AREA_NM: bizNmInput,
        DEPT_NM: deptNmInput,
        USE_FLG: useFlgCheckbox,
      },
      success: (data) => {
        if(data.code) {
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
        this.setFilter();
        // _this.tbList.getRows().forEach(row=>{
        //   row.getCell("DEPT_CD").getElement().addEventListener("click",(e)=>{
        //     _this.rowClick(e,row);
        //   })
        // });

      },
    });

    return true;
  }

  /*
   * @Overview 데이터 필터 함수
   * @Parameter 없음
   * @ 수정 필수 필수!!
   */
  // setFilter() {
  //   // const bizNmInput = document.getElementById("BIZ_AREA_NM");
  //   // const deptNmInput = document.getElementById("DEPT_NM");
  //   // const useFlgCheckbox = document.getElementById("USE_FLG");
  //
  //   // this.tbList.setFilter(data => {
  //
  //   //   const useFlgCondition = useFlgCheckbox.checked ? data.USE_FLG === 'Y' : data.USE_FLG === 'N';
  //   //   const bizNmCondition = !bizNmInput || (data.BIZ_AREA_NM + "|" + data.BIZ_AREA_CD).includes(bizNmInput.value);
  //   //   const deptNmCondition = !deptNmInput || (data.DEPT_NM + "|" + data.DEPT_CD).includes(deptNmInput.value);
  //
  //   //   return useFlgCondition && deptNmCondition && bizNmCondition;
  //
  //   // }, "=", true );
  // }
  setFilter () {

    this.tbList.setFilter(function(data){ //필터링
      return (
          true
          && ( !document.getElementById("USE_FLG")  || ( !document.getElementById("USE_FLG").checked || data.USE_FLG === 'Y' ) )
          // && ( !document.getElementById("S_PLANT_NM") || ( (data.PLANT_CD+"|"+data.PLANT_NM).search(document.getElementById("S_PLANT_NM").value) !== -1 ) )
      )
    }, '=', true);
  };

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I", USE_FLG: "Y" },true);
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
      this.clearRemove(tgt);
    } else {
      tgt.select();
    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    // let editor = tgt.getColumn().getDefinition().editor;
    
    switch (tgt.getField()) {
      case "USE_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        break;
      case "PAR_DEPT_CD":
        // 팝업 열기(부서 선택 팝업)
        popDept({
          // 예시인지라 바꾸어야 함.
          PAR_DEPT_CD: "DEPT_CD",
          PAR_DEPT_NM: "DEPT_NM",
        },tgt.getRow());
        break;
      case "BIZ_AREA_CD":
        // 팝업 열기(부서 선택 팝업)
        popBizArea({
          // 예시인지라 바꾸어야 함.
          BIZ_AREA_CD: "BIZ_AREA_CD",
          BIZ_AREA_NM: "BIZ_AREA_NM",
        },tgt.getRow());
        break;
      case "EMP_NM":
        // 팝업 열기(사원 선택 팝업)
        popWorker({
          // 예시인지라 바꾸어야 함.
          EMP_NO: "EMP_NO",
          EMP_NM: "EMP_SHORT_NM",
        },tgt.getRow());
        break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }


 /*
  * @Overview 추가, 수정 및 삭제 데이터 저장
  * @Parameter 없음
  * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
  */
  putData() {

    // 저장 시 상태 변화 없는 row 요청 X
    if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
      this.getMainList();
      return false;
    }


    const blankObj = [];
    const reqData = [];

    this.tbList.getRows().forEach(row => {

      if(row.getData()['_STATUS_']){
        if(Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'USE_FLG' ).every(key => {

          const value = row._row.data[key];
          return (value === undefined || value === '');
        })){
          blankObj.push(row);
        }else{
          reqData.push(row.getData());
        }
      }
    })


    const postdata = reqData.length == 0 ? false : {
      'mode': 'putDept',
      'reqdata': JSON.stringify(reqData),
    };

    if(!postdata){
      this.getMainList();
      return false;
    };

    if(blankObj.length !== 0){
      kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
        ajax_json({
          url: this.ajaxUrl,
          data: postdata,
          success: (data)=>{
            if (data.code) {
              kuls_success("저장되었습니다.");
              this.getMainList();
            }else{
              kuls_alert(data.mesg);
            }
          },
          error: function (request, status, error) {
            kuls_alert(error.message);
          },
          complete: function () {
          }
        });

      },()=>{
        blankObj.forEach(row=>{
          row.getElement().classList.add("blank-row")
        })
      })
    }else{
      ajax_json({
        url: this.ajaxUrl,
        data: postdata,
        success: (data)=>{
          if (data.code) {
            kuls_success("저장되었습니다.");
            this.getMainList();
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });

    
    }

  }
  changeTableStyle(){


    let colData = this.tbList.getColumns().map(function(v){
      let temp
      if(v !== undefined) {
        temp = { field: v._column.field, width: v._column.width};
      }
      return temp;
    });

    let postdata = {'mode': 'changeTable', 'reqdata' :JSON.stringify(colData) }
    console.log(postdata);
    ajax_json({
      url: this.ajaxUrl,
      data: postdata,
      success: (data)=>{
        if (data.code) {
          kuls_success("저장되었습니다.");
          // this.getMainList();
          this.table = '';
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: function (request, status, error) {
        kuls_alert(error.message);
      },
      complete: function () {
      }
    });
  }

  getColumnStyle() {
    let _this = this;
    let talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);

    ajax_json({
      url: this.ajaxUrl,
      data: {
        mode: "getTableLayout",
      },
      success: (data) => {
        if(data.code) {
          console.log(data.data);
          data.data.forEach(function(v){
            _this.tbList.updateColumnDefinition(v.field, {width:v.width})
          });

        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
        this.setFilter();
      },
    });

    return true;
  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    this.getColumnStyle();
    // field 정의
    const fields = [
      { field:"check", title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter: "rownum", field:"No",title: "No", width: 50, },
      { field: "DEPT_CD", title: "부서코드", width: 150,
        editor: tb_custom_editor.pkCode,
        editorParams:{'type':'upper'},
        formatter: tb_custom_formatter.pkCode,
        formatterParams : {tableClass: this},
      },
      { field: "DEPT_NM",     title: "부서명",       width: 150,
        editor: tb_custom_editor.upper,
        hozAlign:"left",
        cssClass: "editable-cell"
      },
      { field: "PAR_DEPT_CD", title: "상위부서코드", width: 150, editor:tb_custom_editor.pop },
      { field: "PAR_DEPT_NM", title: "상위부서명",   width: 200,},
      { field: "BIZ_AREA_CD", title: "사업장코드",   width: 150,   editor:tb_custom_editor.pop, cssClass:"editable-cell" },
      { field: "BIZ_AREA_NM", title: "사업장명",     width: 200, },
      { field: "EMP_NM",      title: "관리자",       width: 100,   editor:tb_custom_editor.pop },
      { field: "USE_FLG",     title: "사용",         width: 50,   editor:tb_custom_editor.pop, formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: { checkval: "Y" }, },
    ];

    // field 공통 요소
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      height: "100%",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      // headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      rowFormatter:function(row){
        if(row.getData().USE_FLG != "Y"){
          row.getElement().classList.add('text-secondary');
        }
      },
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode: "highlight"
    });

    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      this.getMainList && this.getMainList();
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e, tgt) => {
      this.cellClick && this.cellClick(e, tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 컬럼 너비 조정
    ["click", "keypress"].forEach((evt) => {
      this.widthBtn.addEventListener(evt, () => {
        this.changeTableStyle()
      });
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector("#filter_btn");
      filterBtn.addEventListener(evt, () => {
        // setFilter 또는 setData
        this.getMainList && this.getMainList();
      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector("#put_btn");
      putBtn.addEventListener(evt, () => {
        this.putData && this.putData();
      });
    });
  }
}

const Tb_dept = new Tb_dept_class("#main_container");
Tb_dept.init();
